diff --git a/grub-core/io/offset.c b/grub-core/io/offset.c
new file mode 100644
index 0000000..ebed0eb
--- /dev/null
+++ b/grub-core/io/offset.c
@@ -0,0 +1,111 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/file.h>
+#include <grub/dl.h>
+
+GRUB_MOD_LICENSE ("GPLv3+");
+
+struct grub_offset_file
+{
+  grub_file_t parent;
+  grub_off_t off;
+};
+
+static grub_ssize_t
+grub_offset_read (grub_file_t file, char *buf, grub_size_t len)
+{
+  struct grub_offset_file *data = file->data;
+  if (grub_file_seek (data->parent, data->off + file->offset) == (grub_off_t) -1)
+    return -1;
+  return grub_file_read (data->parent, buf, len);
+}
+
+static grub_err_t
+grub_offset_close (grub_file_t file)
+{
+  struct grub_offset_file *data = file->data;
+
+  if (data->parent)
+    grub_file_close (data->parent);
+
+  /* No need to close the same device twice.  */
+  file->device = 0;
+
+  return 0;
+}
+
+static struct grub_fs grub_offset_fs = {
+  .name = "offset",
+  .dir = 0,
+  .open = 0,
+  .read = grub_offset_read,
+  .close = grub_offset_close,
+  .label = 0,
+  .next = 0
+};
+
+void
+grub_file_offset_close (grub_file_t file)
+{
+  struct grub_offset_file *off_data = file->data;
+  off_data->parent = NULL;
+  grub_file_close (file);
+}
+
+grub_file_t
+grub_file_offset_open (grub_file_t parent, grub_off_t start, grub_off_t size)
+{
+  struct grub_offset_file *off_data;
+  grub_file_t off_file, last_off_file;
+  grub_file_filter_id_t filter;
+
+  off_file = grub_zalloc (sizeof (*off_file));
+  off_data = grub_zalloc (sizeof (*off_data));
+  if (!off_file || !off_data)
+    {
+      grub_free (off_file);
+      grub_free (off_data);
+      return 0;
+    }
+
+  off_data->off = start;
+  off_data->parent = parent;
+
+  off_file->device = parent->device;
+  off_file->data = off_data;
+  off_file->fs = &grub_offset_fs;
+  off_file->size = size;
+
+  last_off_file = NULL;
+  for (filter = GRUB_FILE_FILTER_COMPRESSION_FIRST;
+       off_file && filter <= GRUB_FILE_FILTER_COMPRESSION_LAST; filter++)
+    if (grub_file_filters_enabled[filter])
+      {
+	last_off_file = off_file;
+	off_file = grub_file_filters_enabled[filter] (off_file, parent->name);
+      }
+
+  if (!off_file)
+    {
+      off_data->parent = NULL;
+      grub_file_close (last_off_file);
+      return 0;
+    }
+  return off_file;
+}
diff --git a/grub-core/kern/emu/main.c b/grub-core/kern/emu/main.c
index 0418aae..530d980 100644
--- a/grub-core/kern/emu/main.c
+++ b/grub-core/kern/emu/main.c
@@ -40,6 +40,7 @@
 #include <grub/env.h>
 #include <grub/partition.h>
 #include <grub/i18n.h>
+#include <grub/loader.h>
 
 #include "progname.h"
 #include <argp.h>
@@ -75,9 +76,10 @@ grub_machine_get_bootlocation (char **device, char **path)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags)
 {
-  grub_console_fini ();
+  if (flags & GRUB_LOADER_FLAG_NORETURN)
+    grub_console_fini ();
 }
 
 
diff --git a/grub-core/kern/i386/coreboot/init.c b/grub-core/kern/i386/coreboot/init.c
index 539f342..c2bc7e2 100644
--- a/grub-core/kern/i386/coreboot/init.c
+++ b/grub-core/kern/i386/coreboot/init.c
@@ -122,8 +122,9 @@ grub_machine_get_bootlocation (char **device __attribute__ ((unused)),
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags)
 {
-  grub_vga_text_fini ();
+  if (flags & GRUB_LOADER_FLAG_NORETURN)
+    grub_vga_text_fini ();
   grub_stop_floppy ();
 }
diff --git a/grub-core/kern/i386/efi/init.c b/grub-core/kern/i386/efi/init.c
index 6bd8f3e..7616e62 100644
--- a/grub-core/kern/i386/efi/init.c
+++ b/grub-core/kern/i386/efi/init.c
@@ -35,7 +35,8 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags)
 {
-  grub_efi_fini ();
+  if (flags & GRUB_LOADER_FLAG_NORETURN)
+    grub_efi_fini ();
 }
diff --git a/grub-core/kern/i386/pc/init.c b/grub-core/kern/i386/pc/init.c
index 7befb6b..6c0d79d 100644
--- a/grub-core/kern/i386/pc/init.c
+++ b/grub-core/kern/i386/pc/init.c
@@ -238,8 +238,9 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags)
 {
-  grub_console_fini ();
+  if (flags & GRUB_LOADER_FLAG_NORETURN)
+    grub_console_fini ();
   grub_stop_floppy ();
 }
diff --git a/grub-core/kern/i386/tsc.c b/grub-core/kern/i386/tsc.c
index 9efd633..d8d1a2c 100644
--- a/grub-core/kern/i386/tsc.c
+++ b/grub-core/kern/i386/tsc.c
@@ -24,7 +24,11 @@
 #include <grub/time.h>
 #include <grub/misc.h>
 #include <grub/i386/tsc.h>
+#ifdef GRUB_MACHINE_XEN
+#include <grub/xen.h>
+#else
 #include <grub/i386/pit.h>
+#endif
 #include <grub/cpu/io.h>
 
 /* This defines the value TSC had at the epoch (that is, when we calibrated it). */
@@ -35,6 +39,8 @@ static grub_uint64_t tsc_boot_time;
    in 32-bit.  */
 grub_uint32_t grub_tsc_rate;
 
+#ifndef GRUB_MACHINE_XEN
+
 static void
 grub_pit_wait (grub_uint16_t tics)
 {
@@ -62,6 +68,7 @@ grub_pit_wait (grub_uint16_t tics)
 	     & ~ (GRUB_PIT_SPK_DATA | GRUB_PIT_SPK_TMR2),
              GRUB_PIT_SPEAKER_PORT);
 }
+#endif
 
 grub_uint64_t
 grub_tsc_get_time_ms (void)
@@ -73,6 +80,7 @@ grub_tsc_get_time_ms (void)
   return ((al * grub_tsc_rate) >> 32) + ah * grub_tsc_rate;
 }
 
+#ifndef GRUB_MACHINE_XEN
 /* Calibrate the TSC based on the RTC.  */
 static void
 calibrate_tsc (void)
@@ -86,10 +94,22 @@ calibrate_tsc (void)
 
   grub_tsc_rate = grub_divmod64 ((55ULL << 32), end_tsc - tsc_boot_time, 0);
 }
+#endif
 
 void
 grub_tsc_init (void)
 {
+#ifdef GRUB_MACHINE_XEN
+  grub_uint64_t t;
+  tsc_boot_time = grub_get_tsc ();
+  t = grub_xen_shared_info->vcpu_info[0].time.tsc_to_system_mul;
+  if (grub_xen_shared_info->vcpu_info[0].time.tsc_shift > 0)
+    t <<= grub_xen_shared_info->vcpu_info[0].time.tsc_shift;
+  else
+    t >>= -grub_xen_shared_info->vcpu_info[0].time.tsc_shift;
+  grub_tsc_rate = grub_divmod64 (t, 1000000, 0);
+  grub_install_get_time_ms (grub_tsc_get_time_ms);
+#else
   if (grub_cpu_is_tsc_supported ())
     {
       calibrate_tsc ();
@@ -103,4 +123,5 @@ grub_tsc_init (void)
       grub_fatal ("no TSC found");
 #endif
     }
+#endif
 }
diff --git a/grub-core/kern/i386/xen/hypercall.S b/grub-core/kern/i386/xen/hypercall.S
new file mode 100644
index 0000000..aa47cac
--- /dev/null
+++ b/grub-core/kern/i386/xen/hypercall.S
@@ -0,0 +1,43 @@
+/* hypercall.S - wrappers for Xen hypercalls */
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/symbol.h>
+#include <grub/xen.h>
+
+FUNCTION(grub_xen_hypercall)
+	pushl   %ebp
+	movl    %esp, %ebp
+	pushl   %esi
+	pushl   %edi
+	pushl   %ebx
+
+	/* call number already in %eax. */
+	/* %edx -> %ebx*/
+	/* %ecx -> %ecx*/
+	movl   %edx,  %ebx
+	movl    8(%ebp), %edx
+	movl    12(%ebp), %esi
+	movl    16(%ebp), %edi
+	movl    20(%ebp), %ebp
+	int     $0x82
+	popl   %ebx
+	popl   %edi
+	popl   %esi
+	popl   %ebp
+	retl $16
diff --git a/grub-core/kern/i386/xen/startup.S b/grub-core/kern/i386/xen/startup.S
new file mode 100644
index 0000000..fbe8300
--- /dev/null
+++ b/grub-core/kern/i386/xen/startup.S
@@ -0,0 +1,38 @@
+/* startup.S - bootstrap GRUB itself */
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <config.h>
+#include <grub/symbol.h>
+
+        .file   "startup.S"
+        .text
+        .globl  start, _start
+        .code32
+
+start:
+_start:
+	leal	LOCAL(stack_end), %esp
+	movl	%esi, EXT_C(grub_xen_start_page_addr)
+
+	call	EXT_C(grub_main)
+	/* Doesn't return.  */
+
+	.bss
+	.space (1 << 22)
+LOCAL(stack_end):	
diff --git a/grub-core/kern/ia64/efi/init.c b/grub-core/kern/ia64/efi/init.c
index 7fa6fbf..c514b0a 100644
--- a/grub-core/kern/ia64/efi/init.c
+++ b/grub-core/kern/ia64/efi/init.c
@@ -68,9 +68,10 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags)
 {
-  grub_efi_fini ();
+  if (flags & GRUB_LOADER_FLAG_NORETURN)
+    grub_efi_fini ();
 }
 
 void
diff --git a/grub-core/kern/ieee1275/init.c b/grub-core/kern/ieee1275/init.c
index 7d03a8a..23218bf 100644
--- a/grub-core/kern/ieee1275/init.c
+++ b/grub-core/kern/ieee1275/init.c
@@ -277,10 +277,13 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags)
 {
-  grub_ofdisk_fini ();
-  grub_console_fini ();
+  if (flags & GRUB_LOADER_FLAG_NORETURN)
+    {
+      grub_ofdisk_fini ();
+      grub_console_fini ();
+    }
 }
 
 static grub_uint64_t
diff --git a/grub-core/kern/mips/arc/init.c b/grub-core/kern/mips/arc/init.c
index 44b4171..d90a476 100644
--- a/grub-core/kern/mips/arc/init.c
+++ b/grub-core/kern/mips/arc/init.c
@@ -168,7 +168,7 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags __attribute__ ((unused)))
 {
 }
 
diff --git a/grub-core/kern/mips/loongson/init.c b/grub-core/kern/mips/loongson/init.c
index 19f2d63..508f473 100644
--- a/grub-core/kern/mips/loongson/init.c
+++ b/grub-core/kern/mips/loongson/init.c
@@ -214,7 +214,7 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags __attribute__ ((unused)))
 {
 }
 
diff --git a/grub-core/kern/mips/qemu_mips/init.c b/grub-core/kern/mips/qemu_mips/init.c
index 782f17f..5410d7b 100644
--- a/grub-core/kern/mips/qemu_mips/init.c
+++ b/grub-core/kern/mips/qemu_mips/init.c
@@ -74,7 +74,7 @@ grub_machine_init (void)
 }
 
 void
-grub_machine_fini (void)
+grub_machine_fini (int flags __attribute__ ((unused)))
 {
 }
 
diff --git a/grub-core/kern/x86_64/xen/hypercall.S b/grub-core/kern/x86_64/xen/hypercall.S
new file mode 100644
index 0000000..9b04db6
--- /dev/null
+++ b/grub-core/kern/x86_64/xen/hypercall.S
@@ -0,0 +1,53 @@
+/* hypercall.S - wrappers for Xen hypercalls */
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2011  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/symbol.h>
+#include <grub/xen.h>
+
+FUNCTION(grub_xen_sched_op)
+	movq $__HYPERVISOR_sched_op, %rax
+	syscall
+	ret
+
+FUNCTION(grub_xen_event_channel_op)
+	movq $__HYPERVISOR_event_channel_op, %rax
+	syscall
+	ret
+
+FUNCTION(grub_xen_update_va_mapping)
+	movq $__HYPERVISOR_update_va_mapping, %rax
+	syscall
+	ret
+
+FUNCTION(grub_xen_mmuext_op)
+	movq %rcx, %r10
+	movq $__HYPERVISOR_mmuext_op, %rax
+	syscall
+	ret
+
+FUNCTION(grub_xen_grant_table_op)
+	movq $__HYPERVISOR_grant_table_op, %rax
+	syscall
+	ret
+
+FUNCTION(grub_xen_mmu_update)
+	movq %rcx, %r10
+	movq $__HYPERVISOR_mmu_update, %rax
+	syscall
+	ret
diff --git a/grub-core/kern/x86_64/xen/startup.S b/grub-core/kern/x86_64/xen/startup.S
new file mode 100644
index 0000000..7217ee5
--- /dev/null
+++ b/grub-core/kern/x86_64/xen/startup.S
@@ -0,0 +1,38 @@
+/* startup.S - bootstrap GRUB itself */
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <config.h>
+#include <grub/symbol.h>
+
+        .file   "startup.S"
+        .text
+        .globl  start, _start
+        .code64
+
+start:
+_start:
+	leaq	LOCAL(stack_end), %rsp
+	movq	%rsi, EXT_C(grub_xen_start_page_addr)(%rip)
+
+	call	EXT_C(grub_main)
+	/* Doesn't return.  */
+
+	.bss
+	.space (1 << 22)
+LOCAL(stack_end):	
diff --git a/grub-core/kern/xen/init.c b/grub-core/kern/xen/init.c
new file mode 100644
index 0000000..3bfd99f
--- /dev/null
+++ b/grub-core/kern/xen/init.c
@@ -0,0 +1,571 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2011  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/xen.h>
+#include <grub/term.h>
+#include <grub/misc.h>
+#include <grub/env.h>
+#include <grub/mm.h>
+#include <grub/kernel.h>
+#include <grub/offsets.h>
+#include <grub/memory.h>
+#include <grub/i386/tsc.h>
+#include <grub/term.h>
+#include <grub/loader.h>
+
+grub_addr_t grub_modbase;
+struct start_info *grub_xen_start_page_addr;
+volatile struct xencons_interface *grub_xen_xcons;
+volatile struct shared_info *grub_xen_shared_info;
+volatile struct xenstore_domain_interface *grub_xen_xenstore;
+volatile grant_entry_v2_t *grub_xen_grant_table;
+static const grub_size_t total_grants =
+  GRUB_XEN_PAGE_SIZE / sizeof (grub_xen_grant_table[0]);
+grub_size_t grub_xen_n_allocated_shared_pages;
+
+static grub_xen_mfn_t
+grub_xen_ptr2mfn (void *ptr)
+{
+  grub_xen_mfn_t *mfn_list =
+    (grub_xen_mfn_t *) grub_xen_start_page_addr->mfn_list;
+  return mfn_list[(grub_addr_t) ptr >> GRUB_XEN_LOG_PAGE_SIZE];
+}
+
+void *
+grub_xen_alloc_shared_page (domid_t dom, grub_xen_grant_t * grnum)
+{
+  void *ret;
+  grub_xen_mfn_t mfn;
+  volatile grant_entry_v2_t *entry;
+
+  /* Avoid 0.  */
+  for (entry = grub_xen_grant_table;
+       entry < grub_xen_grant_table + total_grants; entry++)
+    if (!entry->hdr.flags)
+      break;
+
+  if (entry == grub_xen_grant_table + total_grants)
+    {
+      grub_error (GRUB_ERR_OUT_OF_MEMORY, "out of grant entries");
+      return NULL;
+    }
+  ret = grub_memalign (GRUB_XEN_PAGE_SIZE, GRUB_XEN_PAGE_SIZE);
+  if (!ret)
+    return NULL;
+  mfn = grub_xen_ptr2mfn (ret);
+  entry->full_page.pad0 = 0;
+  entry->full_page.frame = mfn;
+  entry->full_page.hdr.domid = dom;
+  mb ();
+  entry->full_page.hdr.flags = GTF_permit_access;
+  mb ();
+  *grnum = entry - grub_xen_grant_table;
+  grub_xen_n_allocated_shared_pages++;
+  return ret;
+}
+
+void
+grub_xen_free_shared_page (void *ptr)
+{
+  grub_xen_mfn_t mfn;
+  volatile grant_entry_v2_t *entry;
+
+  mfn = grub_xen_ptr2mfn (ptr);
+  for (entry = grub_xen_grant_table + 1;
+       entry < grub_xen_grant_table + total_grants; entry++)
+    if (entry->hdr.flags && entry->full_page.frame == mfn)
+      {
+	mb ();
+	entry->hdr.flags = 0;
+	mb ();
+	entry->full_page.frame = 0;
+	mb ();
+      }
+  grub_xen_n_allocated_shared_pages--;
+}
+
+void
+grub_machine_get_bootlocation (char **device __attribute__ ((unused)),
+			       char **path __attribute__ ((unused)))
+{
+}
+
+static grub_uint8_t window[GRUB_XEN_PAGE_SIZE]
+  __attribute__ ((aligned (GRUB_XEN_PAGE_SIZE)));
+
+#ifdef __x86_64__
+#define NUMBER_OF_LEVELS 4
+#else
+#define NUMBER_OF_LEVELS 3
+#endif
+
+#define LOG_POINTERS_PER_PAGE 9
+#define POINTERS_PER_PAGE (1 << LOG_POINTERS_PER_PAGE)
+
+void
+grub_xen_store_send (const void *buf_, grub_size_t len)
+{
+  const grub_uint8_t *buf = buf_;
+  struct evtchn_send send;
+  int event_sent = 0;
+  while (len)
+    {
+      grub_size_t avail, inbuf;
+      grub_size_t prod, cons;
+      mb ();
+      prod = grub_xen_xenstore->req_prod;
+      cons = grub_xen_xenstore->req_cons;
+      if (prod >= cons + sizeof (grub_xen_xenstore->req))
+	{
+	  if (!event_sent)
+	    {
+	      send.port = grub_xen_start_page_addr->store_evtchn;
+	      grub_xen_event_channel_op (EVTCHNOP_send, &send);
+	      event_sent = 1;
+	    }
+	  grub_xen_sched_op (SCHEDOP_yield, 0);
+	  continue;
+	}
+      event_sent = 0;
+      avail = cons + sizeof (grub_xen_xenstore->req) - prod;
+      inbuf = (~prod & (sizeof (grub_xen_xenstore->req) - 1)) + 1;
+      if (avail > inbuf)
+	avail = inbuf;
+      if (avail > len)
+	avail = len;
+      grub_memcpy ((void *) &grub_xen_xenstore->req[prod & (sizeof (grub_xen_xenstore->req) - 1)],
+		   buf, avail);
+      buf += avail;
+      len -= avail;
+      mb ();
+      grub_xen_xenstore->req_prod += avail;
+      mb ();
+      if (!event_sent)
+	{
+	  send.port = grub_xen_start_page_addr->store_evtchn;
+	  grub_xen_event_channel_op (EVTCHNOP_send, &send);
+	  event_sent = 1;
+	}
+      grub_xen_sched_op (SCHEDOP_yield, 0);
+    }
+}
+
+void
+grub_xen_store_recv (void *buf_, grub_size_t len)
+{
+  grub_uint8_t *buf = buf_;
+  struct evtchn_send send;
+  int event_sent = 0;
+  while (len)
+    {
+      grub_size_t avail, inbuf;
+      grub_size_t prod, cons;
+      mb ();
+      prod = grub_xen_xenstore->rsp_prod;
+      cons = grub_xen_xenstore->rsp_cons;
+      if (prod <= cons)
+	{
+	  if (!event_sent)
+	    {
+	      send.port = grub_xen_start_page_addr->store_evtchn;
+	      grub_xen_event_channel_op (EVTCHNOP_send, &send);
+	      event_sent = 1;
+	    }
+	  grub_xen_sched_op (SCHEDOP_yield, 0);
+	  continue;
+	}
+      event_sent = 0;
+      avail = prod - cons;
+      inbuf = (~cons & (sizeof (grub_xen_xenstore->req) - 1)) + 1;
+      if (avail > inbuf)
+	avail = inbuf;
+      if (avail > len)
+	avail = len;
+      grub_memcpy (buf,
+		   (void *) &grub_xen_xenstore->rsp[cons & (sizeof (grub_xen_xenstore->rsp) - 1)],
+		   avail);
+      buf += avail;
+      len -= avail;
+      mb ();
+      grub_xen_xenstore->rsp_cons += avail;
+      mb ();
+      if (!event_sent)
+	{
+	  send.port = grub_xen_start_page_addr->store_evtchn;
+	  grub_xen_event_channel_op(EVTCHNOP_send, &send);
+	  event_sent = 1;
+	}
+      grub_xen_sched_op(SCHEDOP_yield, 0);
+    }
+}
+
+void *
+grub_xenstore_get_file (const char *dir, grub_size_t *len)
+{
+  struct xsd_sockmsg msg;
+  char *buf;
+  grub_size_t dirlen = grub_strlen (dir) + 1;
+
+  if (len)
+    *len = 0;
+
+  grub_memset (&msg, 0, sizeof (msg));
+  msg.type = XS_READ;
+  msg.len = dirlen;
+  grub_xen_store_send (&msg, sizeof (msg));
+  grub_xen_store_send (dir, dirlen);
+  grub_xen_store_recv (&msg, sizeof (msg));
+  buf = grub_malloc (msg.len + 1);
+  if (!buf)
+    return NULL;
+  grub_dprintf ("xen", "msg type = %d, len = %d\n", msg.type, msg.len);
+  grub_xen_store_recv (buf, msg.len);
+  buf[msg.len] = '\0';
+  if (msg.type == XS_ERROR)
+    {
+      grub_error (GRUB_ERR_IO, "couldn't read xenstorage `%s': %s", dir, buf);
+      grub_free (buf);
+      return NULL;
+    }
+  if (len)
+    *len = msg.len;
+  return buf;
+}
+
+grub_err_t
+grub_xenstore_write_file (const char *dir, const void *buf, grub_size_t len)
+{
+  struct xsd_sockmsg msg;
+  grub_size_t dirlen = grub_strlen (dir) + 1;
+  char *resp;
+
+  grub_memset (&msg, 0, sizeof (msg));
+  msg.type = XS_WRITE;
+  msg.len = dirlen + len + 1;
+  grub_xen_store_send (&msg, sizeof (msg));
+  grub_xen_store_send (dir, dirlen);
+  grub_xen_store_send (buf, len);
+  grub_xen_store_send ("", 1);
+  grub_xen_store_recv (&msg, sizeof (msg));
+  resp = grub_malloc (msg.len + 1);
+  if (!resp)
+    return grub_errno;
+  grub_dprintf ("xen", "msg type = %d, len = %d\n", msg.type, msg.len);
+  grub_xen_store_recv (resp, msg.len);
+  resp[msg.len] = '\0';
+  if (msg.type == XS_ERROR)
+    {
+      grub_dprintf ("xen", "error = %s\n", resp);
+      grub_error (GRUB_ERR_IO, "couldn't read xenstorage `%s': %s",
+		  dir, resp);
+      grub_free (resp);
+      return grub_errno;
+    }
+  grub_free (resp);
+  return GRUB_ERR_NONE;
+}
+
+/* FIXME: error handling.  */
+grub_err_t
+grub_xenstore_dir (const char *dir,
+		   int (*hook) (const char *dir, void *hook_data),
+		   void *hook_data)
+{
+  struct xsd_sockmsg msg;
+  char *buf;
+  char *ptr;
+  grub_size_t dirlen = grub_strlen (dir) + 1;
+
+  grub_memset (&msg, 0, sizeof (msg));
+  msg.type = XS_DIRECTORY;
+  msg.len = dirlen;
+  grub_xen_store_send (&msg, sizeof (msg));
+  grub_xen_store_send (dir, dirlen);
+  grub_xen_store_recv (&msg, sizeof (msg));
+  buf = grub_malloc (msg.len + 1);
+  if (!buf)
+    return grub_errno;
+  grub_dprintf ("xen", "msg type = %d, len = %d\n", msg.type, msg.len);
+  grub_xen_store_recv (buf, msg.len);
+  buf[msg.len] = '\0';
+  if (msg.type == XS_ERROR)
+    {
+      grub_err_t err;
+      err = grub_error (GRUB_ERR_IO, "couldn't read xenstorage `%s': %s",
+			dir, buf);
+      grub_free (buf);
+      return err;
+    }
+  for (ptr = buf; ptr < buf + msg.len; ptr += grub_strlen (ptr) + 1)
+    if (hook (ptr, hook_data))
+      break;
+  grub_free (buf);
+  return grub_errno;
+}
+
+unsigned long gntframe = 0;
+
+#define MAX_N_UNUSABLE_PAGES 4
+
+static int
+grub_xen_is_page_usable (grub_xen_mfn_t mfn)
+{
+  if (mfn == grub_xen_start_page_addr->console.domU.mfn)
+    return 0;
+  if (mfn == grub_xen_start_page_addr->shared_info)
+    return 0;
+  if (mfn == grub_xen_start_page_addr->store_mfn)
+    return 0;
+  if (mfn == gntframe)
+    return 0;
+  return 1;
+}
+
+static grub_uint64_t
+page2offset (grub_uint64_t page)
+{
+  return page << 12;
+}
+
+static void
+map_all_pages (void)
+{
+  grub_uint64_t total_pages = grub_xen_start_page_addr->nr_pages;
+  grub_uint64_t i, j;
+  grub_xen_mfn_t *mfn_list =
+    (grub_xen_mfn_t *) grub_xen_start_page_addr->mfn_list;
+  grub_uint64_t *pg = (grub_uint64_t *) window;
+  grub_uint64_t oldpgstart, oldpgend;
+  struct gnttab_setup_table gnttab_setup;
+  struct gnttab_set_version gnttab_setver;
+  grub_size_t n_unusable_pages = 0;
+  struct mmu_update m2p_updates[2 * MAX_N_UNUSABLE_PAGES];
+
+  grub_memset (&gnttab_setver, 0, sizeof (gnttab_setver));
+
+  gnttab_setver.version = 2;
+  grub_xen_grant_table_op (GNTTABOP_set_version, &gnttab_setver, 1);
+
+  grub_memset (&gnttab_setup, 0, sizeof (gnttab_setup));
+  gnttab_setup.dom = DOMID_SELF;
+  gnttab_setup.nr_frames = 1;
+  gnttab_setup.frame_list.p = &gntframe;
+
+  grub_xen_grant_table_op (GNTTABOP_setup_table, &gnttab_setup, 1);
+
+  for (j = 0; j < total_pages - n_unusable_pages; j++)
+    while (!grub_xen_is_page_usable (mfn_list[j]))
+      {
+	grub_xen_mfn_t t;
+	if (n_unusable_pages >= MAX_N_UNUSABLE_PAGES)
+	  {
+	    struct sched_shutdown arg;
+	    arg.reason = SHUTDOWN_crash;
+	    grub_xen_sched_op (SCHEDOP_shutdown, &arg);
+	    while (1);
+	  }
+	t = mfn_list[j];
+	mfn_list[j] = mfn_list[total_pages - n_unusable_pages - 1];
+	mfn_list[total_pages - n_unusable_pages - 1] = t;
+
+	m2p_updates[2 * n_unusable_pages].ptr
+	  = page2offset (mfn_list[j]) | MMU_MACHPHYS_UPDATE;
+	m2p_updates[2 * n_unusable_pages].val = j;
+	m2p_updates[2 * n_unusable_pages + 1].ptr
+	  = page2offset (mfn_list[total_pages - n_unusable_pages - 1])
+	  | MMU_MACHPHYS_UPDATE;
+	m2p_updates[2 * n_unusable_pages + 1].val = total_pages
+	  - n_unusable_pages - 1;
+
+	n_unusable_pages++;
+      }
+
+  grub_xen_mmu_update (m2p_updates, 2 * n_unusable_pages, NULL, DOMID_SELF);
+
+  total_pages += 4;
+
+  grub_uint64_t lx[NUMBER_OF_LEVELS], nlx;
+  grub_uint64_t paging_start = total_pages - 4 - n_unusable_pages, curpage;
+
+  for (nlx = total_pages, i = 0; i < (unsigned) NUMBER_OF_LEVELS; i++)
+    {
+      nlx = (nlx + POINTERS_PER_PAGE - 1) >> LOG_POINTERS_PER_PAGE;
+      /* PAE wants all 4 root directories present.  */
+#ifdef __i386__
+      if (i == 1)
+	nlx = 4;
+#endif
+      lx[i] = nlx;
+      paging_start -= nlx;
+    }
+
+  oldpgstart = grub_xen_start_page_addr->pt_base >> 12;
+  oldpgend = oldpgstart + grub_xen_start_page_addr->nr_pt_frames;
+
+  curpage = paging_start;
+
+  int l;
+
+  for (l = NUMBER_OF_LEVELS - 1; l >= 1; l--)
+    {
+      for (i = 0; i < lx[l]; i++)
+	{
+	  grub_xen_update_va_mapping (&window,
+				      page2offset (mfn_list[curpage + i]) | 7,
+				      UVMF_INVLPG);
+	  grub_memset (&window, 0, sizeof (window));
+
+	  for (j = i * POINTERS_PER_PAGE;
+	       j < (i + 1) * POINTERS_PER_PAGE && j < lx[l - 1]; j++)
+	    pg[j - i * POINTERS_PER_PAGE] =
+	      page2offset (mfn_list[curpage + lx[l] + j])
+#ifdef __x86_64__
+	      | 4
+#endif
+	      | 3;
+	}
+      curpage += lx[l];
+    }
+
+  for (i = 0; i < lx[0]; i++)
+    {
+      grub_xen_update_va_mapping (&window,
+				  page2offset (mfn_list[curpage + i]) | 7,
+				  UVMF_INVLPG);
+      grub_memset (&window, 0, sizeof (window));
+
+      for (j = i * POINTERS_PER_PAGE;
+	   j < (i + 1) * POINTERS_PER_PAGE && j < total_pages; j++)
+	if (j < paging_start && !(j >= oldpgstart && j < oldpgend))
+	  pg[j - i * POINTERS_PER_PAGE] = page2offset (mfn_list[j]) | 0x7;
+	else if (j < grub_xen_start_page_addr->nr_pages)
+	  pg[j - i * POINTERS_PER_PAGE] = page2offset (mfn_list[j]) | 5;
+	else if (j == grub_xen_start_page_addr->nr_pages)
+	  {
+	    pg[j - i * POINTERS_PER_PAGE] =
+	      page2offset (grub_xen_start_page_addr->console.domU.mfn) | 7;
+	    grub_xen_xcons = (void *) (grub_addr_t) page2offset (j);
+	  }
+	else if (j == grub_xen_start_page_addr->nr_pages + 1)
+	  {
+	    pg[j - i * POINTERS_PER_PAGE] =
+	      grub_xen_start_page_addr->shared_info | 7;
+	    grub_xen_shared_info = (void *) (grub_addr_t) page2offset (j);
+	  }
+	else if (j == grub_xen_start_page_addr->nr_pages + 2)
+	  {
+	    pg[j - i * POINTERS_PER_PAGE] =
+	      page2offset (grub_xen_start_page_addr->store_mfn) | 7;
+	    grub_xen_xenstore = (void *) (grub_addr_t) page2offset (j);
+	  }
+	else if (j == grub_xen_start_page_addr->nr_pages + 3)
+	  {
+	    pg[j - i * POINTERS_PER_PAGE] = page2offset (gntframe) | 7;
+	    grub_xen_grant_table = (void *) (grub_addr_t) page2offset (j);
+	  }
+    }
+
+  grub_xen_update_va_mapping (&window, 0, UVMF_INVLPG);
+
+  mmuext_op_t op[3];
+
+  op[0].cmd = MMUEXT_PIN_L1_TABLE + (NUMBER_OF_LEVELS - 1);
+  op[0].arg1.mfn = mfn_list[paging_start];
+  op[1].cmd = MMUEXT_NEW_BASEPTR;
+  op[1].arg1.mfn = mfn_list[paging_start];
+  op[2].cmd = MMUEXT_UNPIN_TABLE;
+  op[2].arg1.mfn = mfn_list[oldpgstart];
+
+  grub_xen_mmuext_op (op, 3, NULL, DOMID_SELF);
+
+  for (i = oldpgstart; i < oldpgend; i++)
+    grub_xen_update_va_mapping ((void *) (grub_addr_t) page2offset (i),
+				page2offset (mfn_list[i]) | 7, UVMF_INVLPG);
+  void *new_start_page, *new_mfn_list;
+  new_start_page = (void *) (grub_addr_t) page2offset (paging_start - 1);
+  grub_memcpy (new_start_page, grub_xen_start_page_addr, 4096);
+  grub_xen_start_page_addr = new_start_page;
+  new_mfn_list = (void *) (grub_addr_t)
+    page2offset (paging_start - 1
+		 - ((grub_xen_start_page_addr->nr_pages
+		     * sizeof (grub_uint64_t) + 4095) / 4096));
+  grub_memcpy (new_mfn_list, mfn_list, grub_xen_start_page_addr->nr_pages
+	       * sizeof (grub_uint64_t));
+  grub_xen_start_page_addr->pt_base = page2offset (paging_start);
+  grub_xen_start_page_addr->mfn_list = (grub_addr_t) new_mfn_list;
+
+  grub_addr_t heap_start = grub_modules_get_end ();
+  grub_addr_t heap_end = (grub_addr_t) new_mfn_list;
+
+  grub_mm_init_region ((void *) heap_start, heap_end - heap_start);
+}
+
+extern char _end[];
+
+void
+grub_machine_init (void)
+{
+#ifdef __i386__
+  grub_xen_vm_assist (VMASST_CMD_enable, VMASST_TYPE_pae_extended_cr3);
+#endif
+
+  grub_modbase = ALIGN_UP ((grub_addr_t) _end
+			   + GRUB_KERNEL_MACHINE_MOD_GAP,
+			   GRUB_KERNEL_MACHINE_MOD_ALIGN);
+
+  map_all_pages ();
+
+  grub_console_init ();
+
+  grub_tsc_init ();
+
+  grub_xendisk_init ();
+
+  grub_boot_init ();
+}
+
+void
+grub_exit (void)
+{
+  struct sched_shutdown arg;
+
+  arg.reason = SHUTDOWN_poweroff;
+  grub_xen_sched_op (SCHEDOP_shutdown, &arg);
+  while (1);
+}
+
+void
+grub_machine_fini (int flags __attribute__ ((unused)))
+{
+  grub_xendisk_fini ();
+  grub_boot_fini ();
+}
+
+grub_err_t
+grub_machine_mmap_iterate (grub_memory_hook_t hook, void *hook_data)
+{
+  grub_uint64_t total_pages = grub_xen_start_page_addr->nr_pages;
+  grub_uint64_t usable_pages = grub_xen_start_page_addr->pt_base >> 12;
+  if (hook (0, page2offset (usable_pages), GRUB_MEMORY_AVAILABLE, hook_data))
+    return GRUB_ERR_NONE;
+
+  hook (page2offset (usable_pages), page2offset (total_pages - usable_pages),
+	GRUB_MEMORY_RESERVED, hook_data);
+
+  return GRUB_ERR_NONE;
+}
